/**************************************************************************
*   Amarok 2 lyrics script to search for lyrics on Google                 *
*   								          *
*                                                                         *
*   Copyright                                                             *
*   (C) 2008 Antoine Gaillard <antoine.gaillard13@gmail.com>              *
*   									  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
**************************************************************************/

Importer.loadQtBinding( "qt.core" );
Importer.loadQtBinding( "qt.network" );
Importer.loadQtBinding( "qt.xml" );


function onFinished( dat )
{
    try
    {
		dat=dat.replace ( /\<[^>]*em[^>]*\>/gi , "" );
		var results=dat.match( /http:\/\/www\.[^\"]*[^=]*\=l\>/g );
		var xml="<suggestions page_url=\"http://www.google.com\">";		
		for (i=0;i<results.length;i++)
		{
			url_temp=results[i].match(/[^"]*\"/);
			url_temp=url_temp[0].replace( "&" , "&amp;");
			//title=titles[i];
			//title=title.replace(/\=l\>/ , "");
			xml += "<suggestion artist=\"" + (i+1) + "\" title=\""+url_temp+" url=\"" + url_temp + " />";
		}
		xml+="</suggestions>";
		Amarok.Lyrics.showLyrics(xml);		
		
	
	
    }
    catch( err )
    {
        Amarok.debug( "error: " + err );
    }
}

function setCharset( dat )
{
	try
	{
			charset=dat.match( /charset\=[^&"]*/ );
			if (charset)
			{				
				charset=charset[0].replace("charset=" , "") ;
				if ( charset.toLowerCase()=="utf-8" )
				{
						displayLyrics(dat);
				}
				else
				{
					new Downloader( new QUrl(global_url), displayLyrics , charset );
				}
			}
			else
			{
				displayLyrics(dat);
			}
			
			
		
	}
		
	catch( err )
	{
		Amarok.debug( "error: " + err );
    	}
}


function displayLyrics(dat)
{		
	try
	{
		//Cleaning the page and matching what could be lyrics
		dat=dat.replace( /\<[^>]*[biup]\>/ig , "" );			
		dat=dat.match( /[^>]*\<[^>]{0,1}[bB][rR][^&gt;>]{0,2}>/g);
		
		html="<h3>"+global_artist+" : "+global_title+"</h3><br>";
		for (i=0;i<dat.length;i++)			
		{
			html+=dat[i];
		}
		Amarok.Lyrics.showLyricsHtml( html );
	}
	catch(err)
	{
		Amarok.debug( "error: " + err );
	}
}


function getLyrics( artist, title, url )
{
    try
    {
				
		if (url)
		{	
			global_url=url;			
			//Amarok.alert(url);			
			link=new QUrl(url);
			new Downloader( link, setCharset );
		}
		else
		{
			global_artist=artist;
			global_title=title;
			//Remove "featuring"
			title=title.replace( /[\ (]f[et][\.a]{0,1}(t){0,1}([\.u]){0,1}(ring){0,1}\ /mig , " " );
			artist=artist.replace( /[\ (]f[et][\.a]{0,1}(t){0,1}(\.){0,1}\ /mig , " " );
			//Remove special chars
			title=title.replace( /[\.\-\_\(\)\@\,\;\&\\\/\"\']/mig, " " );
			artist=artist.replace( /[\.\-\_\(\)\@\,\;\&\\\/\"\']/mig, " " );	
			//Shorten the search args
			if ( title.length > 15 )
			{	
				var lastspace = title.indexOf( " " , 15 );
				
				if ( lastspace > 15 )
				{
					title = title.substring( 0 , lastspace );
				}
			}
			if ( artist.length > 15 )
			{	
				var lastspace = artist.indexOf( " " , 15 );
				
				if ( lastspace > 15 )
				{
					artist = artist.substring( 0 , lastspace );
				}
			}
			
			//Create The Url       
			var gurl = new QUrl( "http://www.google.com/search" );
			gurl.addQueryItem( "num" , nb_res );
			gurl.addQueryItem( "q", ( artist + "+" + title + '+lyrics' ) );
			Amarok.debug( "request URL: " + gurl.toString() );

			//Downloading It!
			new Downloader( gurl, onFinished );
		}
	}
	
    catch( err )
    {
        Amarok.debug( "error: " + err );
    }
}
global_url="";
global_title="";
global_artist="";
nb_res="10";

Amarok.Lyrics.fetchLyrics.connect( getLyrics );

